﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Management;

namespace dumpsids
{
	class Program
	{
		static void Main(string[] args)
		{
			ManagementScope scope = new ManagementScope();

			// Query groups
			ObjectQuery query = new ObjectQuery(
				"select * from Win32_GroupUser");

			using (ManagementObjectSearcher search = new ManagementObjectSearcher(scope, query))
			{
				foreach (ManagementObject wmiObject in search.Get())
				{
					ManagementObject group = new ManagementObject(
						new ManagementPath(wmiObject["GroupComponent"].ToString()));
					ManagementObject user = new ManagementObject(
						new ManagementPath(wmiObject["PartComponent"].ToString()));

					Console.WriteLine("{0} -> {1} # {2} memberof {3}",
						user["SID"], group["SID"],
						user["Name"], group["Name"]);
				}
			}
		}
	}
}
